************************************************************************
* ISPACK FORTRAN SUBROUTINE LIBRARY FOR SCIENTIFIC COMPUTING
* Copyright (C) 1998--2016 Keiichi Ishioka <ishioka@gfd-dennou.org>
*
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public
* License along with this library; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
* 02110-1301 USA.
************************************************************************
************************************************************************
*     Operate Laplacian                                       2016/02/02
************************************************************************
      SUBROUTINE SUCLAP(MM,S,SL,D,IFLAG)

      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'mpif.h'
      DIMENSION S(*),SL(*)
!      DIMENSION S((MM/NP+1)*(2*(MM+1)-MM/NP*NP))
!      DIMENSION SL((MM/NP+1)*(2*(MM+1)-MM/NP*NP))
      DIMENSION D(*)
!      DIMENSION D((MM/NP+1)*(2*(MM+1)-MM/NP*NP)*2)

      CALL MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)
      CALL MPI_COMM_RANK(MPI_COMM_WORLD,IP,IERR)

      ND=(MM/NP+1)*(2*(MM+1)-MM/NP*NP)

!$omp parallel do
      DO L=1,ND
        SL(L)=D(L+(IFLAG-1)*ND)*S(L)
      END DO
!$omp end parallel do

      END
